@echo off
title My Hero Academia - One's Justice - Multi-Language Translation Patch
set "hactool=tools\hactool.exe"
set "heropatcher=tools\heropatcher.exe"
set "quickbms=tools\quickbms.exe"
set "unpack=tools\unreal_tournament_4.bms"
set "u4pak=tools\u4pakmod.py"
set "keys=keys.txt"
set "minspace=    13421772800"
set "titlekey="
set "basegame=%~1"
set "update=%~2"

if "%~z1" LSS "%~z2" (
	set "basegame=%~2"
	set "update=%~1"
)
if not exist "%hactool%" (
	echo Error: hactool not found!
	goto end
)
if not exist "%heropatcher%" (
	echo Error: heropatcher not found!
	goto end
)
if not exist "%quickbms%" (
	echo Error: QuickBMS not found!
	goto end
)
if not exist "%unpack%" (
	echo Error: unreal_tournament_4.bms not found!
	goto end
)
if not exist "%u4pak%" (
	echo Error: u4pak.py not found!
	goto end
)
if not exist "%keys%" (
	echo Error: Keys not found!
	goto end
)
python -V > nul 2> nul
if %errorlevel%==9009 (
	echo Error: Python is not installed!
	goto end
)
if not exist "%basegame%" (
	echo Error: Unable to open the file!
	goto end
)
setlocal enabledelayedexpansion
set "padding=               "
for /f "tokens=2" %%A in (
  'wmic LogicalDisk Get DeviceID^,FreeSpace ^| %windir%\System32\find.exe /i "%~d0"'
) do set "freespace=%padding%%%A"
set "freespace=%freespace:~-15%"
setlocal disabledelayedexpansion
if "%freespace%" LSS "%minspace%" (
  echo Error: You must have at least 12.5 GB of free hard drive space!
  goto end
)

:choosecfw
set /p cfw="Type the custom firmware you are using (atmosphere, ReiNX, sxos) and press enter: "
if "%cfw%" == "atmosphere" goto chooselang
if "%cfw%" == "ReiNX" goto chooselang
if "%cfw%" == "sxos" (
	echo Warning: The patch won't work on SX OS 1.8 and 1.9!
	goto chooselang
)
echo Error: Type a valid custom firmware!
goto choosecfw

:chooselang
set /p language="Type a language (en-US, fr, it, de, es, pt-BR, es-419, ko, zh-Hant) and press enter: "
if "%language%" == "en-US" goto main
if "%language%" == "fr" goto main
if "%language%" == "it" goto main
if "%language%" == "de" goto main
if "%language%" == "es" goto main
if "%language%" == "pt-BR" goto main
if "%language%" == "es-419" goto main
if "%language%" == "ko" goto main
if "%language%" == "zh-Hant" goto main
echo Error: Type a valid language!
goto chooselang

:error
echo Error: Something went wrong!
goto end

:main
echo Extracting the NCAs...
mkdir "hero_temp" > nul 2> nul
%hactool% -k %keys% --intype=xci --securedir=hero_temp\ncas "%basegame%" > nul 2> nul
%hactool% -k %keys% --intype=pfs0 --pfs0dir=hero_temp\ncas "%basegame%" > nul 2> nul
:findnca
setlocal enabledelayedexpansion
set "ncasize=0"
set "ncaname="
for /r %%i in (hero_temp\ncas\*) do (
	if !ncasize! LSS %%~zi (
		set ncaname=%%~ni.nca
		set ncasize=%%~zi
	)
)
setlocal disabledelayedexpansion
if not exist "hero_temp\ncas\%ncaname%" goto error
echo Extracting the RomFS...
%hactool% -k %keys% --romfsdir=hero_temp\romfs "hero_temp\ncas\%ncaname%" > nul 2> nul
rmdir "hero_temp\ncas" /S /Q > nul 2> nul
if not exist "hero_temp\romfs\HeroGame\Content\Paks\HeroGame-Switch.pak" (
	if "%titlekey%" == "" (
		echo Warning: The dump may be corrupted, there may ^(probably^) be some keys missing in the file "keys.txt"
		echo or the NCA may be encrypted!
		set /p titlekey="Insert the title key (to try to decrypt the NCA) and press enter: "
		echo Extracting the NCAs...
		%hactool% -k %keys% --titlekey=%titlekey% --intype=pfs0 --pfs0dir=hero_temp\ncas "%basegame%" > nul 2> nul
		goto findnca
	)
	goto error
)
echo Extracting the game files...
%quickbms% -Y %unpack% "hero_temp\romfs\HeroGame\Content\Paks\HeroGame-Switch.pak" "hero_temp\pak" > nul 2> nul
title My Hero Academia - One's Justice - Multi-Language Translation Patch
rmdir "hero_temp\romfs" /S /Q > nul 2> nul
if not exist "hero_temp\pak\HeroGame\Content\GUI\Common\DataTable\GameText\DT_CommonText.uexp" (
	echo Can't find the text files!
	echo Error: The dump may be corrupted!
	goto end
)
if not exist "hero_temp\pak\HeroGame\Content\GUI\Common\DataTable\GameText\DT_IngameText.uexp" (
	echo Can't find the text files!
	echo Error: The dump may be corrupted!
	goto end
)
if not exist "hero_temp\pak\HeroGame\Content\GUI\Common\DataTable\GameText\DT_OutgameText.uexp" (
	echo Can't find the text files!
	echo Error: The dump may be corrupted!
	goto end
)
if not exist "hero_temp\pak\HeroGame\Content\GUI\Common\DataTable\GameText\DT_StoryText.uexp" (
	echo Can't find the text files!
	echo Error: The dump may be corrupted!
	goto end
)
if not exist "hero_temp\pak\HeroGame\Content\L10N\%language%\GUI\" (
	echo Can't find the textures!
	echo Error: The dump may be corrupted!
	goto end
)
if exist "%update%" (
	echo Extracting the update files...
	if "%titlekey%" == "" (
		%hactool% -k %keys% --intype=pfs0 --pfs0dir=hero_temp\ncas_update "%update%" > nul 2> nul
	) else (
		%hactool% -k %keys% --titlekey=%titlekey% --intype=pfs0 --pfs0dir=hero_temp\ncas_update "%update%" > nul 2> nul
	)
	:findncaupdate
	setlocal enabledelayedexpansion
	set "ncaupdsize=0"
	set "ncaupdname="
	for /r %%i in (hero_temp\ncas_update\*) do (
		if !ncaupdsize! LSS %%~zi (
			set ncaupdname=%%~ni.nca
			set ncaupdsize=%%~zi
		)
	)
	setlocal disabledelayedexpansion
	%hactool% -k %keys% --romfsdir=hero_temp\romfs_update "hero_temp\ncas_update\%ncaupdname%" > nul 2> nul
	rmdir "hero_temp\ncas_update" /S /Q > nul 2> nul
	if not exist "hero_temp\romfs_update\HeroGame\Content\Paks\HeroGame-Switch_0_P.pak" (
		if "%titlekey%" == "" (
			set /p titlekey="Insert the title key and press enter: "
			%hactool% -k %keys% --titlekey=%titlekey% --intype=pfs0 --pfs0dir=hero_temp\ncas_update "%update%" > nul 2> nul
			goto findncaupdate
		)
		echo Error: Can't extract the update files!
		goto patchfiles
	)
	%quickbms% -Y %unpack% "hero_temp\romfs_update\HeroGame\Content\Paks\HeroGame-Switch_0_P.pak" "hero_temp\pak_update" > nul 2> nul
	title My Hero Academia - One's Justice - Multi-Language Translation Patch
	rmdir "hero_temp\romfs_update" /S /Q > nul 2> nul
	echo D|xcopy "hero_temp\pak_update\HeroGame\Content\L10N\%language%\GUI" "hero_temp\pak\HeroGame\Content\L10N\%language%\GUI" /s /y > nul 2> nul
	echo D|xcopy "hero_temp\pak_update\HeroGame\Content\GUI\Common\DataTable\GameText" "hero_temp\pak\HeroGame\Content\GUI\Common\DataTable\GameText" /s /y > nul 2> nul
	rmdir "hero_temp\pak_update\HeroGame\Content\L10N" /S /Q > nul 2> nul
	echo D|xcopy "hero_temp\pak_update" "hero_temp\patch" /s /y > nul 2> nul
	rmdir "hero_temp\pak_update" /S /Q > nul 2> nul
)
:patchfiles
echo Patching the files...
echo D|xcopy "hero_temp\pak\HeroGame\Content\L10N\%language%\GUI" "hero_temp\patch\HeroGame\Content\GUI" /s /y > nul 2> nul
echo F|xcopy "hero_temp\pak\HeroGame\Content\GUI\Common\DataTable\GameText\DT_CommonText.uexp" "hero_temp\patch\HeroGame\Content\GUI\Common\DataTable\GameText\DT_CommonText.uexp" /y > nul 2> nul
echo F|xcopy "hero_temp\pak\HeroGame\Content\GUI\Common\DataTable\GameText\DT_IngameText.uexp" "hero_temp\patch\HeroGame\Content\GUI\Common\DataTable\GameText\DT_IngameText.uexp" /y > nul 2> nul
echo F|xcopy "hero_temp\pak\HeroGame\Content\GUI\Common\DataTable\GameText\DT_OutgameText.uexp" "hero_temp\patch\HeroGame\Content\GUI\Common\DataTable\GameText\DT_OutgameText.uexp" /y > nul 2> nul
echo F|xcopy "hero_temp\pak\HeroGame\Content\GUI\Common\DataTable\GameText\DT_StoryText.uexp" "hero_temp\patch\HeroGame\Content\GUI\Common\DataTable\GameText\DT_StoryText.uexp" /y > nul 2> nul
%heropatcher% %language% "hero_temp\patch\HeroGame\Content\GUI\Common\DataTable\GameText\DT_CommonText.uexp" > nul 2> nul
%heropatcher% %language% "hero_temp\patch\HeroGame\Content\GUI\Common\DataTable\GameText\DT_IngameText.uexp" > nul 2> nul
%heropatcher% %language% "hero_temp\patch\HeroGame\Content\GUI\Common\DataTable\GameText\DT_OutgameText.uexp" > nul 2> nul
%heropatcher% %language% "hero_temp\patch\HeroGame\Content\GUI\Common\DataTable\GameText\DT_StoryText.uexp" > nul 2> nul
echo Repacking the patched files...
mkdir "hero_patch\%cfw%\titles\0100E0F008E64000\romfs\HeroGame\Content\Paks" > nul 2> nul
python %u4pak% pack -z "hero_patch\%cfw%\titles\0100E0F008E64000\romfs\HeroGame\Content\Paks\HeroGame-Switch_0_P.pak" "hero_temp\patch" > nul 2> nul
if not exist "hero_patch\%cfw%\titles\0100E0F008E64000\romfs\HeroGame\Content\Paks\HeroGame-Switch_0_P.pak" (
	python -V
	echo You should try with another version of Python ^(version 2.7.15 is reccomended^).
	goto error
)
echo Plus Ultra!

:end
rmdir "hero_temp" /S /Q > nul 2> nul
pause
exit