//Hero Text Patcher 0.3 by lucaboy

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define numberOfLangs 10
#define sizeOfFlag 0x0a

void findFlags(unsigned char *buffer, unsigned char *flags);
void swapFlags(unsigned char *buffer, unsigned long size, int language);

int main(int argc, char *argv[])
{
	FILE *uexp;
	int language;
	
    if(argc < 3) {
        printf("Error: Too few arguments!\n");
        return -1;
    }
    
    if (strcmp(argv[1], "en-US") == 0) {
        language = 1;
    }
    else if (strcmp(argv[1], "fr") == 0) {
        language = 2;
    }
    else if (strcmp(argv[1], "it") == 0) {
        language = 3;
    }
    else if (strcmp(argv[1], "de") == 0) {
        language = 4;
    }
    else if (strcmp(argv[1], "es") == 0) {
        language = 5;
    }
    else if (strcmp(argv[1], "pt-BR") == 0) {
        language = 6;
    }
    else if (strcmp(argv[1], "es-419") == 0) {
        language = 7;
    }
    else if (strcmp(argv[1], "ko") == 0) {
        language = 8;
    }
    else if (strcmp(argv[1], "zh-Hant") == 0) {
        language = 9;
    }
    else {
        printf("Argument \"%s\" is not valid!\n", argv[1]);
        return -2;
    }
    uexp = fopen(argv[2], "rb+");
    if(uexp == NULL) {
        printf("Error: Unable to open the file!\n");
        return -3;
    }
    fseek(uexp, 0, SEEK_END);
	unsigned long size = ftell(uexp);
	fseek(uexp, 0, SEEK_SET);
	unsigned char *buffer = (unsigned char *)calloc(size, sizeof(unsigned char));
	if(buffer == NULL) {
		printf("Something went wrong!\n");
		return -4;
	}
	fread(buffer, sizeof(unsigned char), size, uexp);
	fseek(uexp, 0, SEEK_SET);
    swapFlags(buffer, size, language);
    fwrite(buffer, sizeof(unsigned char), size, uexp);
    free(buffer);
    fclose(uexp);
    printf("Done!\n");
    return 0;
}

void findFlags(unsigned char *buffer, unsigned char *flags) {
	unsigned long position = 0x35;
	unsigned int lengthOfString = 0;
	int language = 0;
	memcpy(&flags[language * 10], &buffer[position], sizeOfFlag);
	for(language = 1; language < numberOfLangs; language++) {
		position += sizeOfFlag + 6;
		lengthOfString = ((buffer[position + 3] & 0xFF) << 24) | ((buffer[position + 2] & 0xFF) << 16) | ((buffer[position + 1] & 0xFF) << 8) | ((buffer[position] & 0xFF));
		position += lengthOfString + 9;
		memcpy(&flags[language * 10], &buffer[position], sizeOfFlag);
	}
}

void swapFlags(unsigned char *buffer, unsigned long size, int language) {
	unsigned char flags[numberOfLangs][sizeOfFlag];
	unsigned long position;
	int index = 0, rotation = 0;
	findFlags(buffer, *flags);
	for(position = 0x35; position < size; position++) {
		if(buffer[position] == flags[language * (rotation % 2)][index]) {
			index++;
			if(index == sizeOfFlag) {
				memcpy(&buffer[position - (sizeOfFlag - 1)], flags[language * ((rotation + 1) % 2)], sizeOfFlag);
				index = 0;
				rotation++;
			}
		}
		else if(index > 1 || buffer[position] != flags[language * (rotation % 2)][0]){
			index = 0;
		}
	}
}
